// Shader2sided.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Shader2sided.h"

#include "MainFrm.h"
#include "Shader2sidedDoc.h"
#include "Shader2sidedView.h"

#include "dx9/RendererDX9.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShader2sidedApp

BEGIN_MESSAGE_MAP(CShader2sidedApp, CWinApp)
	//{{AFX_MSG_MAP(CShader2sidedApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShader2sidedApp construction

CShader2sidedApp::CShader2sidedApp()
{
  m_pRenderer = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CShader2sidedApp object

CShader2sidedApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CShader2sidedApp initialization

BOOL CShader2sidedApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CShader2sidedDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CShader2sidedView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
  m_pMainWnd->SetWindowPos(NULL,0,0,0,0,SWP_NOSIZE);

  // create renderer
  //
  m_pRenderer = new Mythos::CRendererDX9;
  if(!m_pRenderer) return FALSE;

  u32 u32Flags = Mythos::CRendererDX9::_WINDOWED_ | Mythos::CRendererDX9::_ZBUFFER_;
  if(!m_pRenderer->Create(m_pMainWnd->m_hWnd,u32Flags))
    {
    MessageBox(NULL,"renderer initialization failed","ERROR",MB_ICONEXCLAMATION|MB_OK);
    delete m_pRenderer;
    return FALSE;
    }

  //
	return TRUE;
}

//

int CShader2sidedApp::ExitInstance() 
{
  delete m_pRenderer;
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CShader2sidedApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CShader2sidedApp message handlers


BOOL CShader2sidedApp::OnIdle(LONG lCount) 
{
	if(CWinApp::OnIdle(lCount)) return TRUE;

  // find active document - The MFC Answer Book, 2.18
  CWnd* pWnd = AfxGetMainWnd();
  if(pWnd)
    {
    CFrameWnd* pMainFrame   = static_cast<CFrameWnd*>(pWnd);
    CFrameWnd* pActiveFrame = pMainFrame->GetActiveFrame();

    if(pActiveFrame)
      {
      CDocument* pDoc = pActiveFrame->GetActiveDocument();
      if(pDoc)
        {
        pDoc->UpdateAllViews(NULL,_IDLE_);
        return TRUE;                                        // give me more processing time
        }
      }
    }

  return FALSE;
}
